#!/usr/bin/perl -U
# ************************************************
#
#      Web Dialer v0.8 by Dietrich Heise
#          dietrich@pegestorf.de
#
#     http://www.pegestorf.de/webwvdial/
#
# im cgi Verzeichnis werden die Dateien 
# online.log, online.dat und provider.dat 
# traffic.dat erzeugt
# ************************************************
# Edit this

# the base URL from your web server, were the skript runs
$baseURL    = "http://10.0.0.1";
# the base dir for your web server
$htmlDIR    = "/"; 
# the cgi-bin dir, were this skript is located
$baseCGI    = "/cgi-bin";
# the filename for this skript
$skript     = "webdial.cgi";
# the device of your modem / isdn-adapter / adsl-modem 
$dev        = "ppp0";
# not allowed to get data from the skript for the following IP-Addresses
@notallow   = ("10.0.0.1");# more => ("IP1","IP2")

# Passwords if you dont want to use let it blank
$configpass = "";
$logpass = "";
# if you do not need one you must know what you are doing
$adminpass  = "change";

# the color for the html sides
$bgcolor        = "#aabdaa"; # default #aabdaa
$bordercolor    = "#000000"; # default #000000
$titlecolor     = "#ad7a7a"; # default #ad7a7a
$tablecolor     = "#aa9daa"; # default #aa9daa
$colorconnect   = "#009900"; # default #009900
$colordeconnect = "#990000"; # default #990000
$passwordcolor  = "#990000"; # default #990000
$gesamtcolor	= "#0000BB"; # default #0000BB

# show the var/log/... buttons?
# usefull for debugging the connection
# 0 -> no
# 1 -> yes
$varlogbuttons = 1;
# how many lines should be displayed?  
$loglines = 70;

# allow shutdown
# if you want to use your skript must have root
# permissions (chmod u+s webwvdial.cgi)
# 0 -> no
# 1 -> yes
$allowshutdown = 1;

# refreshtime while connecting
# use 0 for no refresh
$refreshtime   = 1;

# Timezone
# use  1 for MEZ (+1)
# use  0 for GMT ( 0)
# and so on...
$timezone = 1;

# the language you want to use
# for german  use -> &german
# for english use -> &english
# for french  use -> &francais (thanks to jerome ROUER)
&german;      

# ************************************************
# Other options    
# choose what to use: wvdial -> 0  or asdl -> 1 or isdn -> 2 
$type = 1;
# the command to start the adsl-connection
#$dialcommand = "/usr/sbin/isdnctrl dial ippp0&";
$dialcommand = "pppd pty \"/usr/sbin/pppoe -I eth0\"";
# $deconnectcommand = "isdnctrl hangup ippp0";
# only for isdn-p-t-p ip
# if you don't have
# isdn uncomment this line!
# $isdnip="192.168.0.1"; 
# ************************************************
# END OF CONFIG 
# ************************************************
$htmlURL   = $baseURL.$htmlDIR;
$skriptURL = $baseURL.$baseCGI."/".$skript;

use CGI qw/:standard/;

$myip = remote_addr();  #IP des Rechners herausfinden

&allowed;
&online;
&wann;
if (!(((param('status')) eq "startppp") || ((param('status')) eq "startppp2"))){
  &ifpppdown;
}

# Shutdown ***************************************
if (((param('status')) eq "halt") && ($allowshutdown)){&halt;}
# Startppp ***************************************
elsif ((param('status')) eq "startppp"){&startppp;}  
# Connecting *************************************
elsif ((param('status')) eq "startppp2"){&startppp2;}
# Stopppp ****************************************
elsif ((param('status')) eq "stopppp"){&stopppp;} 
# Config *****************************************
elsif ((param('status')) eq "config"){&config;}
# Logdatei ***************************************
elsif ((param('status')) eq "log"){&logs;}
# Status ***************************************** 
elsif ((param('status')) eq "stat"){&status;}
# Messages *************************************** 
elsif (((param('status')) eq "messages") && ($varlogbuttons)){&messages;}
# Http Errors ************************************ 
elsif (((param('status')) eq "httpe") && ($varlogbuttons)){&httpe;}
# Sollte nicht vorkommen *************************
elsif (param('status')) {
    print header;
    print "<BODY BGCOLOR=\"$bgcolor\">\nStatus = ".param('status')."\n</BODY>\n</HTML>";
}
# Startseite *************************************
else {
    &buttons($message[0]);
    &onlinestat;
    &configure;
    @pppaddr = `/sbin/ifconfig`;
    foreach $addr (@pppaddr){
      if(($addr =~ /$dev/) && ($type ne 2)){
        &printFound;
      }
    }
    if ($type eq 2) {
      $isdn = 1;
      if ($isdnip){
        foreach $addr (@pppaddr){
          if($addr =~ /$isdnip/){
            $isdn = 0;
          }
        }
      }
      if ($isdn) {&printFound;}
    }
    print end_html;
}
exit;
# ************************************************
sub buttons{
    print header;
    print "<HTML>\n<HEAD>\n<TITLE>".@_[0]."</TITLE>\n</HEAD>\n";
    print "<BODY BGCOLOR=\"$bgcolor\">\n";
    print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
    print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n";
    &by;
    print "</CENTER></TD></TR><TR BGCOLOR=\"$tablecolor\"><TD>";
    print "<TABLE CELLPADDING=\"0\" cellspacing=\"0\" border=\"0\">\n<TR>\n";
	&pppbutton;
	&haltbutton;
	if ($type eq "0") {&configbutton;}
	&logbutton;
	&statusbutton;
	&infobutton;
	if ($varlogbuttons){
	  &messagesbutton;
	  &httpebutton;
	}
    print "</TR>\n</TABLE>\n";
    print "</TD></TR>\n";
    print "</TABLE></TD></TR></TABLE><BR>";

    print "\t<!-- Ende der Buttonleiste -->\n";	
}
sub pppbutton{
    &online;
    if ($istonline == 1){
	&stoppppbutton;
    }
    else{
	&startpppbutton;
    }
}
sub startpppbutton{
  print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"startppp\">\n";
  print "<INPUT type=submit name=submit value=\"$message[1]\">";
  print "</FORM>\n</TD>\n";
}
sub stoppppbutton{
  print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"stopppp\">\n";
  print "<INPUT type=submit name=submit value=\"$message[2]\">\n";
  print "</FORM>\n</TD>\n";
}
sub haltbutton{
  if ($allowshutdown){ 
    if (!(@online)){
      print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
      print "<INPUT type=hidden name=\"status\" value=\"halt\">\n";
      print "<INPUT type=submit name=submit value=\"$message[3]\">\n";
      print "</FORM>\n</TD>\n";
    }
  }
}
sub configbutton{
  if (param('status') ne "config"){
    print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
    print "<INPUT type=submit name=submit value=\"$message[4]\">\n";
    print "</FORM>\n</TD>\n";
  }
}
sub logbutton{
  print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"log\">\n";
  print "<INPUT type=submit name=submit value=\"$message[5]\">\n";
  print "</FORM>\n</TD>\n";
}
sub statusbutton{
  print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
  print "<INPUT type=hidden name=\"status\" value=\"stat\">\n";
  print "<INPUT type=submit name=submit value=\"$message[6]\">\n";
  print "</FORM>\n</TD>\n";
}
sub infobutton{
  print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
  print "<INPUT type=submit name=submit value=\"$message[7]\">\n";
  print "</FORM>\n</TD>\n";
}
sub onlinestat{
  &online;
  print "\t<!-- Begin des Onlinestatus -->\n";
  print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
  print "<TR BGCOLOR=\"$titlecolor\">\n<TD>\n<CENTER><B>$message[8]</B></CENTER>\n";
  print "</TD>\n</TR>\n<TR>";
  print "<TD>";
  foreach $online (@online){
    @inhalt = split(/\e/,$online);
    $ip = $inhalt[0];
    print "&nbsp;".$ip."<BR>\n";
  }
  if (!(@online)){
    print "&nbsp;$message[9]<BR>\n";
  }
  print "</TD></TABLE></TD></TR></TABLE><BR>";

  #print "<HR>\n";
  #print "<H1>$message[8]</H1>\n";
  #foreach $online (@online){
#    @inhalt = split(/\e/,$online);
#    $ip = $inhalt[0];
#    print "&nbsp;".$ip."<BR>\n";
#  }
#  if (!(@online)){
#    print "&nbsp;$message[9]<BR>\n";
#  }
  print "\t<!-- Ende des Onlinestatus -->\n";
  
}
sub configure{
  print "\t<!-- Begin Configure -->\n";
  print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
  print "<TR BGCOLOR=\"$titlecolor\">\n<TD>\n<CENTER><B>";
  
  
  if ($type eq "0"){
    open (config, "</etc/wvdial.conf");
      @config = <config>;
    close config;
    chop @config;
    foreach $config (@config){
      if ($config =~ /Username/){
        $config  =~ s/(Username = )//;
        $username = $config;
      }
      elsif ($config =~ /Password/){
        $config =~ s/(Password = )//;
        $password = $config;
      }
      elsif ($config =~ /Phone/){
        $config =~ s/(Phone = )//;
        $phone = $config;
      }
      elsif ($config =~ /Provider/){
        $config =~ s/(Provider = )//;
        $provider = $config;
      }
    } 
    print "$message[10]</B></CENTER>\n";
    print "</TD>\n</TR>\n<TR>";
    print "<TD>";
    print "<TABLE>\n";
    if ($type ne 2){
      print "<TR>\n<TD>$message[11]</TD>\n<TD><B>".$provider."</B></TD>\n</TR>\n";
      print "<TR>\n<TD>$message[12]&nbsp;</TD>\n<TD><B>".$phone."</B></TD>\n</TR>\n";
    }else{
      print "<TR>\n<TD>ISDN</TD>\n</TR>\n";
    }
    #print "<TR>\n<TD>$message[13]</TD>\n<TD><B>".$username."</B></TD>\n</TR>\n";  #Kann bei Internet-by-Surf auskommentiert werden
    #print "<TR>\n<TD>$message[14]</TD>\n<TD><B>".$password."</B></TD>\n</TR>\n";
    print "</TABLE>\n<BR>\n";
    &bytes(1);	
  }else{
    print "$message[40]</B></CENTER>\n";
    print "</TD>\n</TR>\n<TR>";
    print "<TD>";
    &bytes(1);
  }
  print "</TD></TR></TABLE></TD></TR></TABLE><BR>";
  print "\t<!-- Ende Configure -->\n";
}
# ************************************************
sub wann{
  if ($_[0]){
    $time = $_[0];
  }else{
    $time = time;
  }
  ($sec, $min, $std, $tag, $mon, $jahr) = localtime($time);
  $sec = &zs($sec);
  $min = &zs($min);
  $std = &zs($std);
  $tag = &zs($tag);
  $mon = &zs(++$mon);
  $jahr = $jahr + 1900;
  $datum = $tag.".".$mon.".".$jahr." ".$std.":".$min.":".$sec;
}
sub zs{
  if (length ($_[0]) < 2 ){
    return "0".$_[0];
  }else{
    return $_[0];
  }
}
# * Welche IP's schon online gemeldet sind *******
sub online{
  open (online, "<online.dat");
    @online = <online>;
  close (online);
  chop @online;
  $istonline = 0;
  foreach $line (@online){
    my @inhalt = split(/\e/,$line);
    $ip = $inhalt[0];
    if ($myip eq $ip) {
      $istonline = 1;
      # Dieser Rechner ist schon online 
    }
  }
}
# Rechner runterfahren ***************************
sub halt{
  print header;
  print "<BODY BGCOLOR=\"$bgcolor\">\n<H1>$message[15]</H1>\n";
  print end_html;
  `/sbin/halt`;
}
sub startppp{
  &online;
  if ($istonline){
    &error($message[16]);
    exit;
  }
  undef $found;
    @pppaddr = `/sbin/ifconfig`;
    foreach $addr (@pppaddr){
      if (($addr =~ /$dev/) && ($type ne 2)){
          $found = 1;
      }
    }
    if ($type eq 2) {
      $found = 1;
      if ($isdnip){
        foreach $addr (@pppaddr){
          if($addr =~ /$isdnip/){
            $found = 0;
          }
        }
      }
    }
    open (LOG, ">>online.log");
      print LOG $myip."\e1\e".$datum."\e".$time."\n";
    close (LOG);
    open (ONLINE, ">online.dat");
    print ONLINE $myip."\e".$time."\n";
    foreach $ip (@online){
      if (($myip."\e".$time) ne $ip){
        print ONLINE $ip."\n";
      }
    }
    close (ONLINE);
    
open (traffic, "<traffic.log");
      @traffic = <traffic>;
    close (traffic);
    $help = $traffic[-1];
    $help = substr($help,-1,1);
    if ($help ne "\e"){
      open (traffic, ">>traffic.log");
        print traffic $time."\e";
      close (traffic);
    }
    undef @traffic;
    undef $help;
    if ($found){
      &online;
      &buttons($message[17]);
      &printFound;
      #&logbuttons;
    }else{
      if ($refreshtime){
        print redirect($skriptURL."?status=startppp2");
      }else{
        print redirect($skriptURL."?status=");
      }
      if (($type eq "1") || ($type eq "2")) {
        system($dialcommand);
      }else{
        system("wvdial&");
      }
      system("/usr/local/httpd/cgi-bin/webdial_checker.cgi&");
    }
}
sub startppp2{
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    if(($addr =~ /$dev/) && ($type ne 2)){
      $found = 1;
    }
  }
  if ($type eq 2) {
    $found = 1;
    if ($isdnip){
      foreach $addr (@pppaddr){
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  if ($found){
    &buttons($message[17]);
    &printFound;
    #&logbuttons;
  }else{
    print header;
    print "<HTML>\n<HEAD>\n<TITLE>$message[18]</TITLE>\n";
    print "<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"${refreshtime}; URL=${skriptURL}?status=startppp2\">\n";
    print "</HEAD>\n<BODY BGCOLOR=\"$bgcolor\">\<H1>$message[18]</H1>\n</BODY>\n</HTML>\n";
  }
}
sub printFound{
  print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
  print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n";
  print "<B>$message[19]</B>";
  print "</CENTER></TD></TR><TR BGCOLOR=\"$tablecolor\"><TD>";
  #print "<H5>$message[21]</H5>\n";
  #with Suse 6.4 use here  `/sbin/ifconfig -l $dev`
  @pppip = `/sbin/ifconfig $dev`;
  @colsplit = split(":",$pppip[1]);
  @inetarr = split(" ", $colsplit[1]);
  print "<P>\n$message[22]\n $inetarr[0]\n</P>\n";
  @inetarr = split(" ", $colsplit[2]);
  print "<P>\n$message[23]\n $inetarr[0]\n</P>\n";
  print "<P>\n$message[24]\n $colsplit[3]\n</P>\n";
  print "</TD></TR></TABLE></TD></TR></TABLE>";
}
# Abwahl *****************************************
sub stopppp{
  $found = 0;
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    if(($addr =~ /$dev/) && ($type ne 2)){
      $found = 1; # Verbindung noch da
    }
  }
  if ($type eq 2) {
    $found = 1;
    if ($isdnip){
      foreach $addr (@pppaddr){
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  &online;
  if (!($istonline)){
    &error($message[25]);
    exit;
  }
  open (LOG, ">>online.log");
  open (ONLINE, ">online.dat");
  if ($found){
    $eintrag = 0;
    foreach $ip (@online){
      if (!($ip =~ /$myip/)){
        if (!($ip =~ /^$/)){
          print ONLINE $ip."\n";
        }
      }else{
        $eintrag = 1;
        @zeile = split(/\e/,$ip);
        print LOG $myip."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
      }
    }
    if ($eintrag == 0){
      @zeile = split(/\e/,$ip);
      print LOG $myip."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
    }
  }else{
    foreach $ip (@online){
      @zeile = split(/\e/,$ip);
      print LOG $zeile[0]."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
    }
  }
  close (LOG);
  close (ONLINE);
  &online;
  if (!(@online)){
    if ($type eq 0){
      `/usr/bin/killall wvdial`;
    }elsif ($type eq 2){
      `$deconnectcommand`;
    }
    if ($type ne 2){
      `killall pppd`;
      `/sbin/ifconfig $dev down`;
    }
    @pppaddr = `/sbin/ifconfig`;
    &bytes(0);
    open (traffic, ">>traffic.log");
      print traffic $receive."\e".$transmit."\e".$time."\n";
    close (traffic);
    open (pid, "<webdial.pid");
      $pid = <pid>;
    close (pid);
    system ("kill", "$pid");
    system ("rm","webdial.pid");
  }
  &buttons($message[26]);
  &onlinestat;
  &configure;
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    if(($addr =~ /$dev/) && ($type ne 2)){
      $found = 1;
    }
  }
  if ($type eq 2) {
    $found = 1;
    if ($isdnip){
      foreach $addr (@pppaddr){
        if($addr =~ /$isdnip/){
          $found = 0;
        }
      }
    }
  }
  if ($found){
    &printFound;
  }
  print end_html;
}
sub config{
  &buttons($message[4]);
  &configure;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
    
  if ((param('pass') eq $configpass) || (param('pass') eq $adminpass) || (!$configpass)){
    if (param('status2') eq "change"){&configchange}
  }
  if ((param('pass') eq $adminpass) || (!$adminpass)){
    if (param('status2') eq "sub"){&configsub}
    if (param('status2') eq "add"){&configadd}
  }
  foreach $name (@provider){
    @liste = split /\e/,$name;
    push @alleprovider, $liste[0];
  }

  print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
  print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n";
  print "<B>$message[4]</B>";
  print "</CENTER></TD></TR><TR BGCOLOR=\"$tablecolor\"><TD>";
      
  print start_form;
  print popup_menu(-name=>'providername',-values=>\@alleprovider);
  print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
  print "<INPUT type=hidden name=\"status2\" value=\"change\">\n";
  if ($configpass){
    print "<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit($message[27]);
  print end_form;
  print start_form;
  print popup_menu(-name=>'providername',-values=>\@alleprovider);
  print "<INPUT type=hidden name=\"status\" value=\"config\">\n";
  print "<INPUT type=hidden name=\"status2\" value=\"sub\">\n";
  if ($adminpass){
    print "<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit($message[28]);
  #print "<HR>\n";
  print end_form;
  print start_form,"\n<TABLE>\n<TR>\n<TD>\n",
	  "\t<TABLE>\n\t<TR>\n\t<TD>$message[29]</TD>\n\t<TD>\n\t",textfield('providername'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[12]</TD>\n\t<TD>",textfield('nummer'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[13]</TD>\n\t<TD>",textfield('login'),"</TD>\n\t</TR>\n\t",
	  "<TR>\n\t<TD>$message[14]</TD>\n\t<TD>\n\t",password_field('password')."\n\t",
	  "<INPUT type=hidden name=\"status\" value=\"config\">\n\t",
	  "<INPUT type=hidden name=\"status2\" value=\"add\">\n\t",
	  "</TD>\n\t</TR>\n\t</TABLE>\n</TD>\n<TD>\n";
  if ($adminpass){
    print "<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
  }
  print submit(-name=>'submit',-value=>"$message[35]"),"\n</TD>\n</TR>\n</TABLE>\n",end_form;
  print "</TD></TR></TABLE></TD></TR></TABLE>";
  print end_html;
}
sub configchange{
  $pro = (param('providername'));
  foreach $change (@provider){
    if ($change =~ /$pro/){
      @info = split(/\e/,$change);
      open (con, "</etc/wvdial.conf");
      @con = <con>;
      chop @con;
      close (con);
      open(out, ">/etc/wvdial.conf");
      foreach $va (@con){
	if ($va =~ /Username/){
	  print out "Username = ".$info[2]."\n";
	}
	elsif ($va =~ /Password/){
	  print out "Password = ".$info[3]."\n";
	}
	elsif ($va =~ /Phone/){
	  print out "Phone = ".$info[1]."\n";
	}
	elsif ($va =~ /Provider/){
	  print out "Provider = ".$info[0]."\n";
	}else{
	  print out $va."\n";
        }
      }
      close out;
    }
  }
}    

sub configsub{
  $pro = (param('providername'));
  open (in, "<provider.dat");
    @in = <in>;
  close in;
  chop @in;
  open (out, ">provider.dat");
  foreach $sub (@in){
    @info1 = split(/\e/,$sub);
    if (!($pro eq $info1[0])){
      print out $sub."\n";
    }
  }
  close out;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
}

sub configadd{
  $pro = (param('providername'));
  open (out, ">>provider.dat");
    print out (param('providername'))."\e".(param('nummer'))."\e".(param('login'))."\e";
    print out (param('password'))."\n";
  close out;
  open (provider, "<provider.dat");
    @provider = <provider>;
  close provider;
  chop @provider;
}

sub logs{
  &buttons($message[5]);
  print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
  print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
  print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n";
  print "<B>$message[5]</B>";
  print "</CENTER></TD></TR><TR><TD>";
  if ((!($logpass)) || ( (param('pass') eq $logpass)) || (param('pass') eq $adminpass)){
    open (in, "<online.log");
      @in = <in>;
    close in;
    chop @in;    
    if (param('status2') eq "list"){
      $rechnerip =(param('rechner'));
      print "<FORM ACTION=\"$skriptURL\" METHOD=\"post\">\n<TABLE>\n<TR>\n<TD>\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"traffic\">\n";
      if ($logpass){
        print "<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
      }
      print "<INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[43]\">\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
      print "<PRE>\n";
      $gesamt = 0;
      $rechner = 0;
      foreach $l (@in){
  	if (($l =~ /^${rechnerip}/) || ($rechnerip eq "")){ 
          @zeile = split(/\e/,$l);
  	  if ($zeile[1] == 1){
	    if ($rechner == 0){
	      $rechner = $rechner + 1;
	      $on = $zeile[3];
	    }else{
	      $rechner = $rechner + 1;
	    }
	  }else{
	    $rechner = $rechner - 1;
	    $off = $zeile[3];
	  }
	  if ($zeile[1] eq 0){
	    if ($rechner eq 0){
	      $diff = $off - $on;
	      $gesamt = $gesamt + $diff;
	      &wann($diff-3600*$timezone);
	      print "<FONT COLOR=\"$colordeconnect\"><B>".$zeile[0]."\t ".$zeile[2]."\t$message[34]&nbsp;".$std.":".$min.":".$sec."</B></FONT>\n";
	    }else{
	      print "<FONT COLOR=\"$colordeconnect\"><B>".$zeile[0]."\t ".$zeile[2]."</B></FONT>\n";
	    }
	  }else{
	    print "<FONT COLOR=\"$colorconnect\"><B>".$zeile[0]."\t ".$zeile[2]."</B></FONT>\n";
	  }
        }
      }
      ($sec, $min, $std, $tag) = localtime($gesamt-3600*$timezone);
      $sec = &zs($sec);
      $min = &zs($min);
      $std = &zs($std+(($tag-1)*24));
      print "\n";
      print "<FONT COLOR=\"$gesamtcolor\"><B>$message[30] ".$std.":".$min.":".$sec."</B></FONT>\n";
      print "</PRE>\n";
    }elsif (param('status2') eq "traffic"){
      open (traffic, "<traffic.log");
        @traffic = <traffic>;
      close traffic;
      print "<TABLE border=\"0\">\n";
      my $ages = 0;
      my $bges = 0;
      foreach $i (@traffic){
        if (!($i =~ /\e$/)){
	  @zeile = split("\e", $i);
	  &wann($zeile[0]);
	  $ein = $datum;
	  &wann($zeile[3]);
	  $a = (int $zeile[1]/1024);
	  $b = (int $zeile[2]/1024);
	  print "<TR>\n<TD ALIGN=\"right\"><B>".$a."</B></TD>\n";
	  print "<TD>kB&nbsp;$message[41]</TD>\n";
	  print "<TD ALIGN=\"right\"><B>".$b."</B></TD>\n";
	  print "<TD>kB&nbsp;$message[42]</TD>\n";
	  print "<TD>&nbsp;&nbsp;</TD>\n";
	  print "<TD><FONT COLOR=\"$colordeconnect\"><B>$ein</B></FONT></TD>\n";
	  print "<TD><FONT COLOR=\"$colorconnect\">&nbsp;<B>$datum</B></FONT></TD>\n";
	  print "</TR>\n";
	  $ages += $a;
	  $bges += $b;
	} 
      }
      print "<TR><TD>&nbsp;<TD></TR>";
      print "<TR>\n<TD ALIGN=\"right\"><B>".$ages."</B></TD>\n";
      print "<TD>kB&nbsp;$message[41]</TD>\n";
      print "<TD ALIGN=\"right\"><B>".$bges."</B></TD>\n";
      print "<TD>kB&nbsp;$message[42]</TD>\n";
      print "<TD>&nbsp;&nbsp;</TD>\n";
      print "</TABLE>";
       
      print "<FORM ACTION=\"$skriptURL\" METHOD=\"post\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"list\">\n<TABLE>\n<TR>\n";
      if ($logpass){
        print "<TD>\n<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>";
      }
      print "<TD>\n<INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[36]\">\n</TD>\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
    
    }else{
      # IP's aller geloggten Rechner ermitteln
      undef @ips;
      foreach $l (@in){
        @zeile = split(/\e/,$l);
        push @ips, $zeile[0];
      }
      push @allip, $ips[0];
      foreach $i (@ips){
        for ($j=0;$j<$#allip+1;$j++){
          if ($allip[$j] eq $i) {last;}
	  if ($j == $#allip){
	    push @allip, $i;
	  }
        } 
      }
      undef $time;
      foreach $ip (@allip){
        foreach $l (@in){
	  @zeile = split(/\e/,$l);
	  if (($zeile[1] eq 0) && ($zeile[0] eq $ip)){
	    $time += $zeile[3] - $zeile[4];
	  }
        }
        push @iptime,$time;
        undef $time;
      }
      foreach $t (@iptime){
        $all += $t;
      }
      print "<FORM action=\"$skriptURL\" method=\"post\">\n";
      print "<INPUT type=hidden name=\"status\" value=\"log\">\n";
      print "<INPUT type=hidden name=\"status2\" value=\"list\">\n";
      print "<TABLE BORDER=\"0\" CELLSPACING=\"0\" CELLPADDING=\"0\">\n";
      for ($i=0;$i<$#allip+1;$i++){
        if ($all){
          #$x = sprintf("%.0f",($iptime[$i]/$all*100));
          $x = int ($iptime[$i]/$all*100);
	}else{
	  $x=0;
	}
	print "<TR>\n<TD>\n";
        print "<INPUT TYPE=\"radio\" NAME=\"rechner\" VALUE=\"$allip[$i]\">\n<TT>$allip[$i]</TT>\n&nbsp;&nbsp;</TD>\n";
        print "<TD ALIGN=\"LEFT\">\n<IMG SRC=\"${htmlURL}1.gif\" WIDTH=\"3\" HEIGHT=\"10\" BORDER=\"0\">";
        print "<IMG SRC=\"${htmlURL}2.gif\" WIDTH=\"".4*$x."\" HEIGHT=\"10\" BORDER=\"0\">";
        print "<IMG SRC=\"${htmlURL}3.gif\" WIDTH=\"4\" HEIGHT=\"10\" BORDER=\"0\">\n&nbsp;\n</TD>\n<TD>\n";
        print "<TT>${x}%</TT>\n</TD>\n</TR>\n";
      }
      print "<TR>\n<TD>\n<INPUT TYPE=\"radio\" NAME=\"rechner\" VALUE=\"\">\n<TT>$message[5]</TT>\n</TD>\n";
      print "</TABLE>\n";
      print "<TABLE>\n<TR>\n";
      if ($logpass){
        print "<TD>\n<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>\n";
      }
      print "<TD>\n<INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[36]\">\n";
      print "</TD></TR></TABLE>\n</FORM>\n";
      print "<FORM ACTION=\"$skriptURL\" METHOD=\"post\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
      print "<INPUT TYPE=\"hidden\" NAME=\"status2\" VALUE=\"traffic\">\n<TABLE>\n<TR>\n";
      if ($logpass){
        print "<TD>\n<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n</TD>";
      }
      print "<TD>\n<INPUT TYPE=\"submit\" NAME=\"submit\" VALUE=\"$message[43]\">\n</TD>\n";
      print "\n</TD>\n</TR>\n</TABLE>\n</FORM>";
    }
    #&logbuttons;
    print end_html;
  }else{
    print start_form;
    print "<INPUT TYPE=\"hidden\" NAME=\"status\" VALUE=\"log\">\n";
    print "<FONT COLOR=\"$passwordcolor\">\n<TT>$message[39]&nbsp;</TT>\n</FONT>\n".password_field(-name=>"pass")."\n";
    print submit($message[5]);
    print end_form;
    print end_html;
  }
  print "</TD></TR></TABLE></TD></TR></TABLE>";
}
sub status{
    @pppaddr = `/sbin/ifconfig`;
    &buttons($message[6]);    
    print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
    print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n";
    print "<B>$message[6]</B>";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    foreach $ppp (@pppaddr){
	print $ppp,"";
    }
    print "</TD></TR></TABLE></TD></TR></TABLE>";    
    print end_html;
}

# ************************************************
sub logbuttons{
  print "\t<!-- Begin der LogButtons -->\n";
  if ($varlogbuttons){ 
    #print "<HR>\n";    
    print "<TABLE>\n<TR>\n";
	&messagesbutton;
	&httpebutton;
    print "</TR>\n</TABLE>\n";
  }
  print "\t<!-- Ende der LogButtons -->\n";
}
sub messagesbutton{
    print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"messages\">\n";
    print "<INPUT type=submit name=submit value=\"$message[31]\">\n";
    print "</FORM>\n</TD>\n";
}
sub httpebutton{
    print "<TD>\n<FORM action=\"$skriptURL\" method=\"post\">\n";
    print "<INPUT type=hidden name=\"status\" value=\"httpe\">\n";
    print "<INPUT type=submit name=submit value=\"$message[32]\">\n";
    print "</FORM>\n</TD>\n";
}

sub messages{
    &buttons($message[31]);
    undef @in;
    open (in, "</var/log/messages");
	my @in = <in>;
    close (in);
    chop @in;
    print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
    print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n<B>";
    print "$message[44]";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    for ($i = 1;$i<=$loglines;$i++){
      print $in[-$i]."\n";  
    }
    undef @in;
    print "</TD></TR></TABLE></TD></TR></TABLE>";
    print end_html;
}
sub httpe{
    &buttons($message[33]);
    undef @in;
    open (in, "</var/log/httpd/error_log");
	@in = <in>;
    close (in);
    chop @in;    
    print "<TABLE BGCOLOR=\"$bordercolor\" WIDTH=\"98%\">\n<TR>\n<TD>\n";
    print "<TABLE BORDER=\"0\" CELLPADDING=\"5\" WIDTH=\"100%\" BGCOLOR=\"$tablecolor\">\n";
    print "<TR BGCOLOR=\"$titlecolor\">\n<TD><CENTER>\n<B>";
    print "$message[45]";
    print "</CENTER></TD></TR><TR><TD>";
    print "<PRE>";
    for ($i = 1;$i<=$loglines;$i++){
      print $in[-$i]."\n";
    }
    undef @in;
    print "</TD></TR></TABLE></TD></TR></TABLE>";
    print end_html;
}
sub error{
    print header;
    print "<HEAD>\n<TITLE>".@_[0]."</TITLE>\n</HEAD>\n";
    print "<BODY BGCOLOR=\"$bgcolor\">\n";
    print "<H2>".@_[0]."</H2>\n</BODY>\n</HTML>";
    exit;	
}

sub allowed{
  foreach $i (@notallow){
    if ($myip eq $i){
      &error($message[38]);
    }
  }
}
sub by{
  print "<A HREF=\"http://www.pegestorf.de/webwvdial\"><FONT COLOR=\"#114311\" STYLE=\"text-decoration:none\"><B>WebDialer 0.8</B></FONT></A>";
  print "<FONT >\n&copy;&nbsp;2000&nbsp;by&nbsp;\n<A HREF=\"mailto:dietrich\@pegestorf.de\">\n";
  print "<FONT COLOR=\"#114311\" STYLE=\"text-decoration:none\"><B>Dietrich&nbsp;Heise</B></FONT></A>\n</FONT>\n";
}    

sub bytes{
  my $help = $_[0];
  @bytes = `cat /proc/net/dev`;
  foreach $i (@bytes){
    if($i =~ /$dev/){
      my @help1 = split(":",$i);
      my @help2 = split(" ",$help1[1]);
      if ($help){
        $receive = sprintf ("%d\n",($help2[0]/1024));
        $transmit= sprintf ("%d\n",($help2[8]/1024));
      }else{
        $receive = $help2[0];
        $transmit= $help2[8];
      }
      if ($help){
        print "<TABLE>\n\<TR>\n<TD>\n";
	print "<U>$message[46]</U></TD>\n</TR>\n</TABLE>";
	print "<TABLE>\n\<TR>\n<TD ALIGN=\"right\">${receive}</TD>\n<TD>kB&nbsp;$message[41]</TD>\n</TR>\n";
        print "<TR>\n<TD ALIGN=\"right\">${transmit}</TD>\n<TD>kB&nbsp;$message[42]</TD>\n</TR>\n</TABLE>\n";
      }
    }
  }
}

sub ifpppdown{
  @pppaddr = `/sbin/ifconfig`;
  foreach $addr (@pppaddr){
    if(($addr =~ /$dev/) && (!($isdnip))){
      return; # Verbindung noch da
    }
  }
  if ($type eq 2) {
    $isdn = 1;
    if ($isdnip){
      foreach $addr (@pppaddr){
        if($addr =~ /$isdnip/){
          $isdn = 0;
        }
      }
    }
    if ($isdn) {return;}
  }
  # Verbindung nicht da!
  open (LOG, ">>online.log");
  open (ONLINE, ">online.dat");
  foreach $ip (@online){
    @zeile = split(/\e/,$ip);
    print LOG $zeile[0]."\e0\e".$datum."\e".$time."\e".$zeile[1]."\n";
  }
  close (LOG);
  close (ONLINE);  
}

sub german{
@message = ("Internet Status",
	    "Verbindung starten",
	    "Verbindung trennen",
	    "Herunterfahren",
	    "Konfigurieren",
	    "Logs einsehen",
	    "Online Status",
	    "Informationen",
	    "zur Zeit sind folgende Rechner Online :",
	    "Niemand online",
	    "folgende Verbindung ist eingestellt:", #10
	    "Provider",#11
	    "Telefonnummer",#12
	    "Username",#13
	    "Passwort",
	    "Der Rechner wird herruntergefahren",
	    "ERROR!! Dieser Rechner ist schon online",
	    "Verbindung hergestellt",
	    "Eine Internetverbindung wird hergestellt.",
	    "Eine Internetverbindung wurde hergestellt",
	    "viel Spass beim Surfen",#20
	    "Deine Addresse ist:",
	    "Internet IP Addresse:",
	    "Point-to-Point IP Address:",
	    "Net Mask IP Address:",
	    "ERROR!! Sie sind nicht online!",
	    "Internet Abwahl",
	    "Provider benutzen",
	    "Entfernen",
	    "Provider Bezeichnung",
	    "Gesamte Onlinezeit: ",#30
	    "Messages",
	    "Http Error",
	    "/var/log/httpd/error_log",
	    "Onlinezeit:",
	    "Hinzufuegen",
	    "Liste",
	    "Statistik",
	    "Zugriff von dieser IP Addresse nicht erlaubt",
	    "Passwort:",
	    "Eine ADSL Verbindung ist eingestellt", #40
	    "empfangen",#41
	    "gesendet",#42
	    "Datenvolumen",#43
	    "lezten $loglines Zeilen der /var/log/messages (von neu nach alt)",#44
	    "lezten $loglines Zeilen der /var/log/httpd/error_log (von neu nach alt)",#45
	    "Datentransfer seit letztem Verbindungsaufbau:");
}
sub english{
@message = ("Internet state",
	    "Connect",
	    "Deconnect",
	    "Shutdown",
	    "Configure",
	    "Logs",
	    "Online state",
	    "Information",
	    "the following computers are online :",
	    "no one online",
	    "the following connection will be used:",  #10
	    "Provider",
	    "Phonenumber",
	    "Username",
	    "Password",
	    "Shutdown...",
	    "ERROR!! Your computer already online",
	    "Connection estabished",
	    "A connection will estabished.",
	    "Connection estabished",
	    "have fun",                                #20
	    "Your addresse is:",
	    "Internet IP address:",
	    "Point-to-Point IP address:",
	    "Net Mask IP address:",
	    "ERROR!! Your computer are not online!",
	    "Internet deconnect",
	    "Use provider",
	    "Delete",
	    "Provider name",
	    "Total onlinetime: ",                      #30
	    "Messages",
	    "Http Error",
	    "/var/log/httpd/error_log",
	    "Onlinetime:",
	    "Add",                                     #35
	    "List",
	    "Statistics",
	    "Connetion not allowed for this IP Address",
	    "Password:",
	    "A ADSL Connection is Configured",#40
	    "received",#41
	    "send",#42
	    "Traffic",#43
	    "last $loglines lines of /var/log/messages (form new to old)",#44
	    "last $loglines lines of /var/log/httpd/error_log (form new to old)",#45
	    "data transfered since last connect:");
}

sub francais{
#thanks to jerome ROUER 
@message = ("Statut Internet",
  "Connexion",
  "Dconnexion",
  "Couper",
  "Configurer la connexion",
  "Logs & stats",
  "Statut des interfaces (ifconfig)",
  "Informations",
  "Les ordinateurs suivants sont en ligne :",
  "Aucun n'est en ligne",
  "Sauf autre choix, la configuration de connexion suivante va tre utilise :",  #10
  "Fournisseur d'Accs Internet (FAI) : ",
  "Numro de tlphone de ce FAI :",
  "Nom utilisateur chez le FAI",
  "Mot de passe chez le FAI",
  "Arrter/couper la connexion...",
  "ERREUR!! Votre ordinateur est dj` connect",
  "Connexion tablie",
  "Tentative de connexion en cours...",
  "Connexion tablie avec succs...",
  "Bonne navigation sur le Web...",                                #20
  "Votre adresse est :",
  "Adresse Internet donne par le FAI pour cette connexion :",
  "Adresse IP Point-to-Point du FAI pour cette connexion :",
  "Net Mask IP addresse :",
  "ERREUR!! Votre ordinateur n'est pas en ligne!",
  "Internet et tlphone dconnects.",
  "Utiliser cette connexion",
  "Effacer cette configuration",
  "Nom du FAI",
  "Temps total sous connexion (hh:mm:ss) : ",                      #30
  "Messages systme",
  "Fichiers des erreurs Http",
  "/var/log/httpd/error_log",
  "Temps de connexion :",
  "Ajouter cette configuration ",                                     #35
  "Voir les statistiques de connexion",
  "Rafrachir les fichiers de Logs",
  "Connexion non autorise pour l'adresse IP de cet ordinateur!",
  "Mot de passe pour  ",
#next only english 
  "A ADSL Connection is Configured", #40
  "received",#41
  "send",#42
  "Traffic",#43
  "last $loglines lines of /var/log/messages (form new to old)",#44
  "last $loglines lines of /var/log/httpd/error_log (form new to old)",#45
  "data transfered since last connect:");
}